package org.dromara.art.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.art.domain.bo.ArtMajorBo;
import org.dromara.art.domain.vo.ArtMajorVo;
import org.dromara.art.domain.ArtMajor;
import org.dromara.art.mapper.ArtMajorMapper;
import org.dromara.art.service.IArtMajorService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 艺术专业库Service业务层处理
 *
 * @author ZhouWenTao
 * @date 2026-02-20
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ArtMajorServiceImpl implements IArtMajorService {

    private final ArtMajorMapper baseMapper;

    /**
     * 查询艺术专业库
     *
     * @param majorId 主键
     * @return 艺术专业库
     */
    @Override
    public ArtMajorVo queryById(Long majorId){
        return baseMapper.selectVoById(majorId);
    }

    /**
     * 分页查询艺术专业库列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 艺术专业库分页列表
     */
    @Override
    public TableDataInfo<ArtMajorVo> queryPageList(ArtMajorBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ArtMajor> lqw = buildQueryWrapper(bo);
        Page<ArtMajorVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的艺术专业库列表
     *
     * @param bo 查询条件
     * @return 艺术专业库列表
     */
    @Override
    public List<ArtMajorVo> queryList(ArtMajorBo bo) {
        LambdaQueryWrapper<ArtMajor> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ArtMajor> buildQueryWrapper(ArtMajorBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ArtMajor> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ArtMajor::getMajorId);
        lqw.like(StringUtils.isNotBlank(bo.getMajorName()), ArtMajor::getMajorName, bo.getMajorName());
        lqw.eq(StringUtils.isNotBlank(bo.getEducationLevel()), ArtMajor::getEducationLevel, bo.getEducationLevel());
        lqw.eq(StringUtils.isNotBlank(bo.getMajorIcon()), ArtMajor::getMajorIcon, bo.getMajorIcon());
        lqw.eq(bo.getSchoolingYears() != null, ArtMajor::getSchoolingYears, bo.getSchoolingYears());
        lqw.eq(StringUtils.isNotBlank(bo.getDisciplinePrimary()), ArtMajor::getDisciplinePrimary, bo.getDisciplinePrimary());
        lqw.eq(StringUtils.isNotBlank(bo.getDisciplineSecondary()), ArtMajor::getDisciplineSecondary, bo.getDisciplineSecondary());
        lqw.eq(StringUtils.isNotBlank(bo.getDegreeAwarded()), ArtMajor::getDegreeAwarded, bo.getDegreeAwarded());
        lqw.eq(StringUtils.isNotBlank(bo.getSummary()), ArtMajor::getSummary, bo.getSummary());
        lqw.eq(StringUtils.isNotBlank(bo.getTrainingDirection()), ArtMajor::getTrainingDirection, bo.getTrainingDirection());
        lqw.eq(StringUtils.isNotBlank(bo.getCoreCourses()), ArtMajor::getCoreCourses, bo.getCoreCourses());
        return lqw;
    }

    /**
     * 新增艺术专业库
     *
     * @param bo 艺术专业库
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ArtMajorBo bo) {
        ArtMajor add = MapstructUtils.convert(bo, ArtMajor.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setMajorId(add.getMajorId());
        }
        return flag;
    }

    /**
     * 修改艺术专业库
     *
     * @param bo 艺术专业库
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ArtMajorBo bo) {
        ArtMajor update = MapstructUtils.convert(bo, ArtMajor.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ArtMajor entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除艺术专业库信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
